]> arthur.barton.de Git - MkMySqlDump.git/blobdiff - bin/mkmysqldump
mkmysqldump: Make sure "HOME" is set correctly
[MkMySqlDump.git] / bin / mkmysqldump
index bd76518a710fa3497237949c92d34d8c8424a9fa..e5b8c64ecba6433df422e52c875d8ba4657c8859 100755 (executable)
@@ -1,7 +1,13 @@
 #!/bin/sh
 #
 # mkmysqldump -- dump MySQL (master) data
-# Copyright (c)2015 Alexander Barton <alex@barton.de>
+# Copyright (c)2015-2017 Alexander Barton <alex@barton.de>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+# Please read the file COPYING, README and AUTHORS for more information.
 #
 
 NAME=$(basename "$0")
@@ -49,6 +55,11 @@ ErrorNotice() {
        echo
 }
 
+# Make sure the environment is "sane", for example, mysql(1) depends on the
+# HOME environment variable to be set.
+[ -n "$HOME" ] || HOME=$( getent passwd "${LOGNAME:-root}" | cut -d: -f6 )
+export HOME
+
 for cmd in mysql mysqldump; do
        if ! which "$cmd" >/dev/null 2>&1; then
                echo "$NAME: \"$cmd\" command not found!"
@@ -65,7 +76,7 @@ while [ $# -gt 0 ]; do
                ;;
          "--user"|"-u")
                [ $# -ge 2 ] || Usage
-               MYHOST="$2"
+               MYUSER="$2"
                shift 2
                ;;
          "--password"|"-p")
@@ -109,10 +120,12 @@ while [ $# -gt 0 ]; do
 done
 
 echo "Dumping MySQL server on \"$MYHOST\" (user \"$MYUSER\"):"
+echo
 echo "Started: $(date)"
+
 umask 0077
 
-[ -n "$MYPW" ] && PWSWITCH="--password='$MYPW'" || PWSWITCH=""
+[ -n "$MYPW" ] && PWSWITCH="--password=$MYPW" || PWSWITCH=""
 
 echo "Getting list of databases from server ..."
 DATABASES=$(
@@ -128,13 +141,28 @@ if [ $? -ne 0 ]; then
        exit 1
 fi
 
+echo "Checking slave status ..."
+Slave_IO_Running=""; Slave_SQL_Running=""
+eval "$(echo 'SHOW SLAVE STATUS\G' | mysql -h "$MYHOST" -u "$MYUSER" $PWSWITCH | sed -n '/Running/p' | sed 's/: /=/g')"
+if [ -n "$Slave_IO_Running" -o -n "$Slave_SQL_Running" ]; then
+       if [ "$Slave_IO_Running" = "Yes" -a "$Slave_SQL_Running" = "Yes" ]; then
+               echo "Server is running as MySQL slave, replication is Ok."
+       else
+               echo "Server is running as MySQL slave, but replication FAILED!"
+               ErrorNotice
+               exit 1
+       fi
+else
+       echo "Server is not running as MySQL slave. Ok."
+fi
+
 echo "Will dump the following databases:"
 for d in $DATABASES; do
        echo " - $d"
 done
 
 echo "Dumping SQL data to file \"$OUTFILE\" ..."
-echo "Start date: $(date)"
+echo "Beginning dump: $(date)"
 CMD="mysqldump \
        -h $MYHOST \
        -u $MYUSER \
@@ -145,7 +173,8 @@ $CMD >"$OUTFILE"; r=$?
 if [ -n "$COMPRESS" -a -s "$OUTFILE" -a $r -eq 0 ]; then
        echo "Dump done: $(date)"
        echo "Compressing dump file ($COMPRESS) ..."
-       $COMPRESS "$OUTFILE"
+       $COMPRESS "$OUTFILE" 2>&1
+       [ $? -eq 0 ] || echo "Error compressing dump file!" >&2
 fi
 echo "End: $(date)"
 echo
@@ -162,10 +191,10 @@ fi
 
 if [ $r -eq 0 ]; then
        echo "Dump command exited with code 0, success."
+       echo
 else
        echo "Dump command FAILED with code $r!" >&2
        ErrorNotice
 fi
 
-echo
 exit $r